> For a complete page index, fetch https://developer.close.com/llms.txt

# Create an SMS activity

POST https://api.close.com/api/v1/activity/sms/
Content-Type: application/json

*status* must be one of the following:

 - `inbox` to log an already received SMS.
 - `draft` to create a draft SMS.
 - `scheduled` to send an SMS at a scheduled date and time, which must be specified in the `date_scheduled` field.
 - `outbox` to actually **send** an SMS. To delay SMS sending by a few seconds (to allow undo), specify `send_in` in seconds (must be less than 60).
 - `sent` to log an already sent SMS.

Only drafts can be modified, and their status can be changed to `scheduled` (to send later) or `outbox` (to send immediately). Scheduled SMS, or SMS in outbox that weren't sent yet can be canceled by setting the status back to `draft`.

You have to provide a `local_phone` that will be used to send the SMS. The number you choose has to be associated with a Phone Number of type `internal`. See the [Phone Numbers](https://developer.close.com/api/resources/phone-numbers) paragraph for more details.

A `template_id` referencing an SMS Template may be provided instead of `text` to automatically render that template and use the content as `text`.

When `direction` is not provided, but `status="inbox"`, `direction` will default to "inbound". Otherwise, `direction` defaults to "outbound".

When creating a new SMS with the status set to `inbox`, you can pass the query parameter `send_to_inbox` with the value of `true`  to create a corresponding Inbox Notification for the SMS.

Reference: https://developer.close.com/api/resources/activities/sms/create

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Close API
  version: 1.0.0
paths:
  /activity/sms/:
    post:
      operationId: create
      summary: Create an SMS activity
      description: >-
        *status* must be one of the following:

         - `inbox` to log an already received SMS.
         - `draft` to create a draft SMS.
         - `scheduled` to send an SMS at a scheduled date and time, which must be specified in the `date_scheduled` field.
         - `outbox` to actually **send** an SMS. To delay SMS sending by a few seconds (to allow undo), specify `send_in` in seconds (must be less than 60).
         - `sent` to log an already sent SMS.

        Only drafts can be modified, and their status can be changed to
        `scheduled` (to send later) or `outbox` (to send immediately). Scheduled
        SMS, or SMS in outbox that weren't sent yet can be canceled by setting
        the status back to `draft`.


        You have to provide a `local_phone` that will be used to send the SMS.
        The number you choose has to be associated with a Phone Number of type
        `internal`. See the [Phone
        Numbers](https://developer.close.com/api/resources/phone-numbers)
        paragraph for more details.


        A `template_id` referencing an SMS Template may be provided instead of
        `text` to automatically render that template and use the content as
        `text`.


        When `direction` is not provided, but `status="inbox"`, `direction` will
        default to "inbound". Otherwise, `direction` defaults to "outbound".


        When creating a new SMS with the status set to `inbox`, you can pass the
        query parameter `send_to_inbox` with the value of `true`  to create a
        corresponding Inbox Notification for the SMS.
      tags:
        - subpackage_activitiesSms
      parameters:
        - name: send_to_inbox
          in: query
          required: false
          schema:
            type: boolean
        - name: Authorization
          in: header
          description: Use your API key as the username and leave the password empty.
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SMSActivity'
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                description: Any type
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                description: Any type
        '404':
          description: Not found
          content:
            application/json:
              schema:
                description: Any type
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateSMSActivity'
servers:
  - url: https://api.close.com/api/v1
components:
  schemas:
    CreateSmsActivityAttachmentsItemsContentType:
      type: string
      enum:
        - application/pdf
        - application/vcard
        - audio/3gpp
        - audio/3gpp2
        - audio/L24
        - audio/ac3
        - audio/amr
        - audio/amr-nb
        - audio/basic
        - audio/mp4
        - audio/mpeg
        - audio/ogg
        - audio/vnd.rn-realaudio
        - audio/vnd.wave
        - audio/webm
        - image/bmp
        - image/gif
        - image/jpeg
        - image/jpg
        - image/png
        - image/tiff
        - text/calendar
        - text/csv
        - text/directory
        - text/richtext
        - text/rtf
        - text/vcard
        - text/x-vcard
        - video/3gpp
        - video/3gpp-tt
        - video/3gpp2
        - video/H261
        - video/H263
        - video/H263-1998
        - video/H263-2000
        - video/H264
        - video/mp4
        - video/mpeg
        - video/quicktime
        - video/webm
      title: CreateSmsActivityAttachmentsItemsContentType
    CreateSmsActivityAttachmentsItems:
      type: object
      properties:
        content_type:
          $ref: '#/components/schemas/CreateSmsActivityAttachmentsItemsContentType'
        filename:
          type: string
        url:
          type: string
      required:
        - content_type
        - filename
        - url
      title: CreateSmsActivityAttachmentsItems
    CreateSmsActivityDirection:
      type: string
      enum:
        - inbound
        - outbound
      title: CreateSmsActivityDirection
    CreateSmsActivitySource:
      type: string
      enum:
        - Close.io
        - External
      title: CreateSmsActivitySource
    CreateSmsActivityStatus:
      type: string
      enum:
        - inbox
        - draft
        - scheduled
        - outbox
        - sent
        - error
      title: CreateSmsActivityStatus
    CreateSMSActivity:
      type: object
      properties:
        activity_at:
          type:
            - string
            - 'null'
          format: date-time
        attachments:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/CreateSmsActivityAttachmentsItems'
        contact_id:
          type:
            - string
            - 'null'
        created_by_id:
          type:
            - string
            - 'null'
        date_created:
          type:
            - string
            - 'null'
          format: date-time
        direction:
          $ref: '#/components/schemas/CreateSmsActivityDirection'
        lead_id:
          type:
            - string
            - 'null'
        local_phone:
          type:
            - string
            - 'null'
          description: Phone number in E.164 format
        organization_id:
          type:
            - string
            - 'null'
        remote_phone:
          type:
            - string
            - 'null'
          description: Phone number in E.164 format
        source:
          $ref: '#/components/schemas/CreateSmsActivitySource'
        status:
          $ref: '#/components/schemas/CreateSmsActivityStatus'
        template_id:
          type:
            - string
            - 'null'
        text:
          type:
            - string
            - 'null'
        user_id:
          type:
            - string
            - 'null'
      required:
        - status
      title: CreateSMSActivity
    PhoneActivityDirection:
      type: string
      enum:
        - inbound
        - outbound
      description: Direction of a phone activity, such as a call or an SMS message.
      title: PhoneActivityDirection
    PhoneActivitySource:
      type: string
      enum:
        - Close.io
        - External
      description: >-
        Source of a phone activity. Describes whether the phone activity (such
        as a call or an SMS) was handled by Close's telephony provider or
        handled externally by a 3rd party and is merely logged in Close.
      title: PhoneActivitySource
    MessageStatus:
      type: string
      enum:
        - inbox
        - draft
        - scheduled
        - outbox
        - sent
        - error
      description: Status of a message, such as Email or SMS.
      title: MessageStatus
    SMSActivity:
      type: object
      properties:
        _type:
          type: string
        activity_at:
          type:
            - string
            - 'null'
          format: date-time
        agent_action_reason:
          type:
            - string
            - 'null'
        agent_config_id:
          type:
            - string
            - 'null'
        contact_id:
          type:
            - string
            - 'null'
        cost:
          type:
            - string
            - 'null'
        created_by:
          type:
            - string
            - 'null'
        created_by_name:
          type:
            - string
            - 'null'
        date_created:
          type: string
          format: date-time
        date_scheduled:
          type:
            - string
            - 'null'
          format: date-time
        date_sent:
          type:
            - string
            - 'null'
          format: date-time
        date_updated:
          type: string
          format: date-time
        direction:
          $ref: '#/components/schemas/PhoneActivityDirection'
        error_message:
          type:
            - string
            - 'null'
        id:
          type: string
        lead_id:
          type:
            - string
            - 'null'
        local_country_iso:
          type:
            - string
            - 'null'
        local_phone:
          type:
            - string
            - 'null'
        local_phone_formatted:
          type:
            - string
            - 'null'
        organization_id:
          type: string
        remote_country_iso:
          type:
            - string
            - 'null'
        remote_phone:
          type:
            - string
            - 'null'
        remote_phone_formatted:
          type:
            - string
            - 'null'
        sequence_id:
          type:
            - string
            - 'null'
        sequence_name:
          type:
            - string
            - 'null'
        sequence_subscription_id:
          type:
            - string
            - 'null'
        source:
          $ref: '#/components/schemas/PhoneActivitySource'
        status:
          $ref: '#/components/schemas/MessageStatus'
        template_id:
          type:
            - string
            - 'null'
        text:
          type:
            - string
            - 'null'
        updated_by:
          type:
            - string
            - 'null'
        updated_by_name:
          type:
            - string
            - 'null'
        user_id:
          type:
            - string
            - 'null'
        user_name:
          type:
            - string
            - 'null'
        users:
          type: array
          items:
            type: string
      required:
        - _type
        - activity_at
        - contact_id
        - cost
        - created_by
        - date_created
        - date_scheduled
        - date_sent
        - date_updated
        - direction
        - error_message
        - id
        - lead_id
        - local_country_iso
        - local_phone
        - local_phone_formatted
        - organization_id
        - remote_country_iso
        - remote_phone
        - remote_phone_formatted
        - source
        - status
        - template_id
        - text
        - updated_by
        - user_id
        - users
      title: SMSActivity
  securitySchemes:
    ApiKeyAuth:
      type: http
      scheme: basic
      description: Use your API key as the username and leave the password empty.
    OAuth2:
      type: http
      scheme: bearer

```

## SDK Code Examples

```python activities.sms_create_example
import requests

url = "https://api.close.com/api/v1/activity/sms/"

payload = {
    "status": "inbox",
    "contact_id": "cont_q4xYmlGhA3060dEl0NDJuHRxPMuVjqLn30AFSzh1fRk",
    "direction": "inbound",
    "lead_id": "lead_iuSXNk1x3446ggPVwQS7ynmp8pGRIDieRYiCnuo4yFb",
    "local_phone": "+14154445555",
    "remote_phone": "+18183334444",
    "source": "External",
    "text": "Hi! This is a reminder that we have a call scheduled for 12pm PT today."
}
headers = {
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, auth=("<CLOSE_API_KEY>", ""))

print(response.json())
```

```javascript activities.sms_create_example
const url = 'https://api.close.com/api/v1/activity/sms/';
const credentials = btoa("<CLOSE_API_KEY>:");

const options = {
  method: 'POST',
  headers: {Authorization: `Basic ${credentials}`, 'Content-Type': 'application/json'},
  body: '{"status":"inbox","contact_id":"cont_q4xYmlGhA3060dEl0NDJuHRxPMuVjqLn30AFSzh1fRk","direction":"inbound","lead_id":"lead_iuSXNk1x3446ggPVwQS7ynmp8pGRIDieRYiCnuo4yFb","local_phone":"+14154445555","remote_phone":"+18183334444","source":"External","text":"Hi! This is a reminder that we have a call scheduled for 12pm PT today."}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go activities.sms_create_example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.close.com/api/v1/activity/sms/"

	payload := strings.NewReader("{\n  \"status\": \"inbox\",\n  \"contact_id\": \"cont_q4xYmlGhA3060dEl0NDJuHRxPMuVjqLn30AFSzh1fRk\",\n  \"direction\": \"inbound\",\n  \"lead_id\": \"lead_iuSXNk1x3446ggPVwQS7ynmp8pGRIDieRYiCnuo4yFb\",\n  \"local_phone\": \"+14154445555\",\n  \"remote_phone\": \"+18183334444\",\n  \"source\": \"External\",\n  \"text\": \"Hi! This is a reminder that we have a call scheduled for 12pm PT today.\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.SetBasicAuth("<CLOSE_API_KEY>", "")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby activities.sms_create_example
require 'uri'
require 'net/http'

url = URI("https://api.close.com/api/v1/activity/sms/")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request.basic_auth("<CLOSE_API_KEY>", "")
request["Content-Type"] = 'application/json'
request.body = "{\n  \"status\": \"inbox\",\n  \"contact_id\": \"cont_q4xYmlGhA3060dEl0NDJuHRxPMuVjqLn30AFSzh1fRk\",\n  \"direction\": \"inbound\",\n  \"lead_id\": \"lead_iuSXNk1x3446ggPVwQS7ynmp8pGRIDieRYiCnuo4yFb\",\n  \"local_phone\": \"+14154445555\",\n  \"remote_phone\": \"+18183334444\",\n  \"source\": \"External\",\n  \"text\": \"Hi! This is a reminder that we have a call scheduled for 12pm PT today.\"\n}"

response = http.request(request)
puts response.read_body
```

```java activities.sms_create_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.close.com/api/v1/activity/sms/")
  .basicAuth("<CLOSE_API_KEY>", "")
  .header("Content-Type", "application/json")
  .body("{\n  \"status\": \"inbox\",\n  \"contact_id\": \"cont_q4xYmlGhA3060dEl0NDJuHRxPMuVjqLn30AFSzh1fRk\",\n  \"direction\": \"inbound\",\n  \"lead_id\": \"lead_iuSXNk1x3446ggPVwQS7ynmp8pGRIDieRYiCnuo4yFb\",\n  \"local_phone\": \"+14154445555\",\n  \"remote_phone\": \"+18183334444\",\n  \"source\": \"External\",\n  \"text\": \"Hi! This is a reminder that we have a call scheduled for 12pm PT today.\"\n}")
  .asString();
```

```php activities.sms_create_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.close.com/api/v1/activity/sms/', [
  'body' => '{
  "status": "inbox",
  "contact_id": "cont_q4xYmlGhA3060dEl0NDJuHRxPMuVjqLn30AFSzh1fRk",
  "direction": "inbound",
  "lead_id": "lead_iuSXNk1x3446ggPVwQS7ynmp8pGRIDieRYiCnuo4yFb",
  "local_phone": "+14154445555",
  "remote_phone": "+18183334444",
  "source": "External",
  "text": "Hi! This is a reminder that we have a call scheduled for 12pm PT today."
}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
    'auth' => ['<CLOSE_API_KEY>', ''],
]);

echo $response->getBody();
```

```csharp activities.sms_create_example
using RestSharp;
using RestSharp.Authenticators;

var client = new RestClient("https://api.close.com/api/v1/activity/sms/");
client.Authenticator = new HttpBasicAuthenticator("<CLOSE_API_KEY>", "");
var request = new RestRequest(Method.POST);

request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"status\": \"inbox\",\n  \"contact_id\": \"cont_q4xYmlGhA3060dEl0NDJuHRxPMuVjqLn30AFSzh1fRk\",\n  \"direction\": \"inbound\",\n  \"lead_id\": \"lead_iuSXNk1x3446ggPVwQS7ynmp8pGRIDieRYiCnuo4yFb\",\n  \"local_phone\": \"+14154445555\",\n  \"remote_phone\": \"+18183334444\",\n  \"source\": \"External\",\n  \"text\": \"Hi! This is a reminder that we have a call scheduled for 12pm PT today.\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```